--
-- CreateBigBagEvent
-- Event for createBigBag
--
-- @author John Deere 6930
-- @date 30/06/2019
--

CreateBigBagEvent = {};
local CreateBigBagEvent_mt = Class(CreateBigBagEvent, Event);

InitEventClass(CreateBigBagEvent, "CreateBigBagEvent");

function CreateBigBagEvent:emptyNew()
    local self = Event:new(CreateBigBagEvent_mt);
    return self;
end;

function CreateBigBagEvent:new(object, forced, allowed)
    local self = CreateBigBagEvent:emptyNew();
    self.object = object;
    self.forced = forced;
    self.allowed = allowed;
    return self;
end;

function CreateBigBagEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.forced);
    streamWriteBool(streamId, self.allowed);
end;

function CreateBigBagEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId);
    self.forced = streamReadBool(streamId);
    self.allowed = streamReadBool(streamId);	
    self:run(connection);
end;

function CreateBigBagEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:createBigBag(self.forced, self.allowed, true);
    end;
end;

function CreateBigBagEvent.sendEvent(object, forced, allowed, noEventSend)
    if noEventSend == nil or not noEventSend then
        if g_server ~= nil then
            g_server:broadcastEvent(CreateBigBagEvent:new(object, forced, allowed), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(CreateBigBagEvent:new(object, forced, allowed));
        end;
    end;
end;
