--
-- SendBigBagDataEvent
-- Event for sending BigBagData
--
-- @author John Deere 6930
-- @date 02/07/2019
--

SendBigBagDataEvent = {};
local SendBigBagDataEvent_mt = Class(SendBigBagDataEvent, Event);

InitEventClass(SendBigBagDataEvent, "SendBigBagDataEvent");

function SendBigBagDataEvent:emptyNew()
    local self = Event:new(SendBigBagDataEvent_mt);
    return self;
end;

function SendBigBagDataEvent:new(object, isReceiving, otherObject)
    local self = SendBigBagDataEvent:emptyNew();
    self.object = object;
    self.isReceiving = isReceiving;
    self.otherObject = otherObject;
    return self;
end;

function SendBigBagDataEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.isReceiving);	
    NetworkUtil.writeNodeObject(streamId, self.otherObject);
end;

function SendBigBagDataEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId);
    self.isReceiving = streamReadBool(streamId);	
    self.otherObject = NetworkUtil.readNodeObject(streamId);
    self:run(connection);
end;

function SendBigBagDataEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:sendBigBagData(self.isReceiving, self.otherObject, true);
    end;
end;

function SendBigBagDataEvent.sendEvent(object, isReceiving, otherObject, noEventSend)
    if noEventSend == nil or not noEventSend then
        if g_server ~= nil then
            g_server:broadcastEvent(SendBigBagDataEvent:new(object, isReceiving, otherObject), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(SendBigBagDataEvent:new(object, isReceiving, otherObject));
        end;
    end;
end;
