--
-- SetBigBagRackEvent
-- Event for BigBagRack Object
--
-- @author John Deere 6930
-- @date 02/07/2019
--

SetBigBagRackEvent = {};
local SetBigBagRackEvent_mt = Class(SetBigBagRackEvent, Event);

InitEventClass(SetBigBagRackEvent, "SetBigBagRackEvent");

function SetBigBagRackEvent:emptyNew()
    local self = Event:new(SetBigBagRackEvent_mt);
    return self;
end;

function SetBigBagRackEvent:new(object, bigBagRack)
    local self = SetBigBagRackEvent:emptyNew();
    self.object = object;
    self.bigBagRackNil = (bigBagRack==nil);
    self.bigBagRack = bigBagRack;
    return self;
end;

function SetBigBagRackEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);	
    streamWriteBool(streamId, self.bigBagRackNil);
	if not self.bigBagRackNil then
		NetworkUtil.writeNodeObject(streamId, self.bigBagRack);
	end;
end;

function SetBigBagRackEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId);
	self.bigBagRackNil = streamReadBool(streamId);
	if not self.bigBagRackNil then
		self.bigBagRack = NetworkUtil.readNodeObject(streamId);
	else
		self.bigBagRack = nil;
	end;
    self:run(connection);
end;

function SetBigBagRackEvent:run(connection)
    if self.object ~= nil then
        self.object:setBigBagRack(self.bigBagRack);
    end;
end;