--
-- UpdateBigBagRackEvent
-- Event for sending BigBagData
--
-- @author John Deere 6930
-- @date 30/04/2020
--

UpdateBigBagRackEvent = {};
local UpdateBigBagRackEvent_mt = Class(UpdateBigBagRackEvent, Event);

InitEventClass(UpdateBigBagRackEvent, "UpdateBigBagRackEvent");

function UpdateBigBagRackEvent:emptyNew()
    local self = Event:new(UpdateBigBagRackEvent_mt);
    return self;
end;

function UpdateBigBagRackEvent:new(object, bigbagInRack)
    local self = UpdateBigBagRackEvent:emptyNew();
    self.object = object;
    self.bigbagInRack = bigbagInRack;
    return self;
end;

function UpdateBigBagRackEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.bigbagInRack);
end;

function UpdateBigBagRackEvent:readStream(streamId, connection)
    self.object = NetworkUtil.readNodeObject(streamId);
    self.bigbagInRack = streamReadBool(streamId);
    self:run(connection);
end;

function UpdateBigBagRackEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:updateBigBagRack(self.bigbagInRack, true);
    end;
end;

function UpdateBigBagRackEvent.sendEvent(object, bigbagInRack, noEventSend)
    if noEventSend == nil or not noEventSend then
        if g_server ~= nil then
            g_server:broadcastEvent(UpdateBigBagRackEvent:new(object, bigbagInRack), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(UpdateBigBagRackEvent:new(object, bigbagInRack));
        end;
    end;
end;
