--
-- loadAdditionalBigBagRacks
--
-- @author John Deere 6930
-- @date 14/07/2020
--

AdditionalBigBagRacks = {};
local AdditionalBigBagRacks_mt = Class(AdditionalBigBagRacks);

AdditionalBigBagRacks.modDirectory = g_currentModDirectory;
AdditionalBigBagRacks.avaiableBigBagRacks = {
    {name="FS19_addon_strawHarvest", storeItem="bigBagRack/bigBagRackStrawPellets.xml"},
    {name="FS19_addon_strawHarvest", storeItem="bigBagRack/bigBagRackHayPellets.xml"}
};
AdditionalBigBagRacks.loadedAdditionalItemsFinished = false;


function AdditionalBigBagRacks:loadAdditionalItems(g_storeManager, xmlFilename, baseDir, customEnvironment, isMod, isBundleItem, dlcTitle)
    if not self.loadedAdditionalItemsFinished and customEnvironment == "FS19_bresselUndLadeBigBagPack" and xmlFilename=="bigBagRack/bigBagRackLime.xml" then
        for _, v in pairs(AdditionalBigBagRacks.avaiableBigBagRacks) do
            if g_modIsLoaded[v.name] then
                local completePath = Utils.getFilename(v.storeItem, self.modDirectory);
                local item = g_storeManager:getItemByXMLFilename(completePath);
                if item == nil then
                    g_storeManager:loadItem(v.storeItem, self.modDirectory, customEnvironment, true);
                end;
            end;
        end;
        self.loadedAdditionalItemsFinished = true;
    end;
end;

-- CodeInjection to StrawHarvest 
---Detect valid pallets in the trigger.
function AdditionalBigBagRacks:strawHarvestTriggerPalletCallback(superFunc, triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
    local object = g_currentMission:getNodeObject(otherId)
    if object ~= nil and object.isa ~= nil and object:isa(Vehicle) and object.typeName:find("pallet") or object.typeName:find("bigBag") then
        if onEnter then
            local fillUnitIndex = object:getFirstValidFillUnitToFill(FillType.STRAWPELLETS, true)
            if fillUnitIndex == nil then
                fillUnitIndex = object:getFirstValidFillUnitToFill(FillType.HAYPELLETS, true)
            end

            local fillType = object:getFillUnitFillType(fillUnitIndex)
            if fillType ~= nil then
                if self:getIsFillTypeAllowed(fillType) and object:getFillUnitFillLevel(fillUnitIndex) > 0 then
                    self:raiseActive()
                    self.palletsInTrigger[object] = fillType
                end
            end
        elseif onLeave then
            self.palletsInTrigger[object] = nil
        end
    end
end

-------------------------------
--------Initialization---------
-------------------------------
function init()
	StoreManager.loadItem = Utils.appendedFunction(StoreManager.loadItem, loadAdditionalItems);
    
    if g_modIsLoaded["FS19_addon_strawHarvest"] then
        FS19_addon_strawHarvest.StrawHarvestSellingStation.triggerPalletCallback = Utils.overwrittenFunction(FS19_addon_strawHarvest.StrawHarvestSellingStation.triggerPalletCallback, AdditionalBigBagRacks.strawHarvestTriggerPalletCallback);
    end;
end;

function loadAdditionalItems(g_storeManager, xmlFilename, baseDir, customEnvironment, isMod, isBundleItem, dlcTitle)
    AdditionalBigBagRacks:loadAdditionalItems(g_storeManager, xmlFilename, baseDir, customEnvironment, isMod, isBundleItem, dlcTitle);
end;

init();